// changes the dots from black to white to yellow and green and blue  on mousePressed
// and also saves them or clears them when the buttons are pressed
// screen width wide

int dotsize, gridsize, hordots, vertdots, areaW, areaH, margin;
int[][] dots;
color[] colors = new color[5];
PFont myFont, myBoldFont;
int colorPicked = 0;

void setup() {
  size(displayWidth, displayHeight-50);  
  myFont = createFont("HelveticaNeue-Bold", 12);
  myBoldFont = createFont("HelveticaNeue-Bold", 18, true);

  textFont(myFont);
  smooth();
    dotsize = 25;
  gridsize = 30;
  areaW = displayWidth-gridsize;
  areaH = displayHeight;
  margin = width - areaW;
  noStroke();
  ellipseMode(CORNER);

  colorMode(HSB, 100, 100, 100);

  colors[0] = color(100, 0, 0);
  colors[1] = color(100, 0, 100);
  colors[2] = color(13, 99, 99);
  colors[3] = color(54, 90, 68);
  colors[4] = color(33, 76, 69);

  hordots = areaW/gridsize;
  vertdots = areaH/gridsize;
  
  dots = new int[hordots][vertdots];
  for (int k = 0; k < hordots; k++) {
    for (int l = 0; l < vertdots; l++) {
      dots[k][l] = colorPicked;
    }
  }
  colorPicked = 1;
}

void draw() {
  background(100, 0, 20);
  showSaveButton();
  showColorPicker();

  for (int i = 0; i<hordots; i++) {
    for (int j = 0; j<vertdots; j++) {
    //println(dots.length);
        int arrayspot = dots[i][j];
      fill(colors[arrayspot]);
      ellipse (i*gridsize, j*gridsize, dotsize, dotsize);
    }
  }
  checkIfMousePressed();
}

void checkIfMousePressed() {
  if (mousePressed && mouseX<areaW-5 && mouseX>0 && mouseY < areaH-5 && mouseY>0) {
    int ex = constrain(mouseX/gridsize, 0, hordots-1);
    int why = constrain(mouseY/gridsize, 0, vertdots-1);
    dots[ex][why] = colorPicked;
  }
 
}
void mouseClicked() {
 if (mouseX > areaW && mouseY > 0 && mouseY < gridsize) {
    saveThatImg();
  }
  else if (mouseX > areaW && mouseY > gridsize && mouseY < 2*gridsize) {
    clearAll();
  }
  else if (mouseX > areaW && mouseY > 2*gridsize && mouseY < 3*gridsize) colorPicked = 0;
  else if (mouseX > areaW && mouseY > 3*gridsize && mouseY < 4*gridsize) colorPicked = 1;
  else if (mouseX > areaW && mouseY > 4*gridsize && mouseY < 5*gridsize) colorPicked = 2;
  else if (mouseX > areaW && mouseY > 5*gridsize && mouseY < 6*gridsize) colorPicked = 3;
  else if (mouseX > areaW && mouseY > 6*gridsize && mouseY < 7*gridsize) colorPicked = 4;
}

